from itertools import *

a = '478 38 256 15 34 37 168 127'.split() #тут пишем связи из таблицы (построчно)
s = 'DE DG GC GA BC FB FE FH BH AH'.split() #тут пишем связи из графа (в любом порядке)
print('1 2 3 4 5 6 7 8') #кол-во столбцов
for p in permutations('AHBCFEDG'): #меняем на те буквы или цифры что в задании
    if all(str(p.index(y) + 1 ) in a[p.index(x)] for x,y in s):
        print(*p)